## spdlog 1.15.0+ds

=== debian/changelog ===
spdlog (1:1.15.0+ds-2ubuntu1) plucky; urgency=medium

  * d/rules: Build with LTO disabled for ppc64el.
    - Tests are aborting if LTO is enabled.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 24 Jan 2025 18:13:15 +0000

spdlog (1:1.15.0+ds-2) unstable; urgency=medium

  * Team upload.
  * Backport a patch from upstream to fix building with fmtlib 11.1.

 -- Shengqi Chen <harry@debian.org>  Fri, 10 Jan 2025 17:46:13 +0800

spdlog (1:1.15.0+ds-1) unstable; urgency=medium

  * Team upload.
  * Upload 1.15.0+ds-1 to unstable.

 -- Shengqi Chen <harry@debian.org>  Fri, 10 Jan 2025 17:45:50 +0800

spdlog (1:1.15.0+ds-1~exp2) experimental; urgency=medium

  * Team upload.
  * d/control: move libfmt-dev back into Depends of libspdlog-dev

 -- Shengqi Chen <harry@debian.org>  Mon, 06 Jan 2025 17:24:08 +0800

spdlog (1:1.15.0+ds-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 1.15.0+ds (closes: #1087759)
    + bump soversion to 1.15 accordingly
  * Use cmake+ninja as build system
  * d/patches: remove applied patch & refresh
  * d/control:
    + bump std-ver to 4.7.0 (no changes required)
    + re-organize dependencies and B-D (closes: #1087736)
  * d/tests: add missing dependencies, use ninja to build

 -- Shengqi Chen <harry@debian.org>  Fri, 03 Jan 2025 00:05:38 +0800
