=== debian/changelog ===
spdlog (1:1.15.1+ds-1ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - d/rules: Build with LTO disabled for ppc64el.
      - Tests are aborting if LTO is enabled.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 14 Feb 2025 22:18:38 +0000

spdlog (1:1.15.1+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.15.1+ds.
  * d/patches: remove applied patch.

 -- Shengqi Chen <harry@debian.org>  Wed, 12 Feb 2025 23:07:58 +0800
