## spdlog 1.15.2+ds

=== debian/changelog ===
spdlog (1:1.15.2+ds-2) unstable; urgency=medium

  * Team upload.
  * d/rules: replace apt with dpkg-query (closes: #1098867).
  * d/rules: disable LTO to avoid dh_auto_test failure (closes: #1094031).

 -- Shengqi Chen <harry@debian.org>  Thu, 10 Apr 2025 13:32:02 +0800

spdlog (1:1.15.2+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.15.2+ds.
  * d/control: bump std-ver to 4.7.2 (no changes required).

 -- Shengqi Chen <harry@debian.org>  Mon, 07 Apr 2025 23:35:35 +0800
