=== debian/tests/control ===
Tests: run-tests
Restrictions: allow-stderr
Depends: libspdlog-dev, libfmt-dev, libsystemd-dev, cmake, g++, catch2, ninja-build
