## spdlog 1.15.3%2Bds

=== debian/rules ===
--- 
+++ 
@@ -5,10 +5,10 @@
   export DEB_LDFLAGS_MAINT_APPEND=-latomic
 endif
 
-export DEB_BUILD_MAINT_OPTIONS=hardening=+all $(if $(findstring ppc64el,$(DEB_HOST_ARCH)), optimize=-lto)
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all optimize=-lto
 
 soversion = 1.15
-fmtabi = $(shell apt show libfmt-dev 2>/dev/null | sed -n 's/Depends: .*libfmt\([0-9]*\) .*/\1/p')
+fmtabi = $(shell dpkg-query -W -f '$${Depends}' libfmt-dev | sed -n 's/libfmt\([0-9]*\) .*/\1/p')
 spdlogfmtabi = libspdlog$(soversion)-fmt$(fmtabi)
 
 %:
