=== debian/changelog ===
spdlog (1:1.15.3+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 1.15.3+ds.
  * d/patches: refresh and fix compilation with fmtlib10.

 -- Shengqi Chen <harry@debian.org>  Wed, 04 Jun 2025 22:27:46 +0800
