=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: spdlog
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Michael R. Crusoe <crusoe@debian.org>
 Section: libdevel
 Priority: optional
@@ -12,7 +11,7 @@
                pkg-kde-tools,
                libsystemd-dev [linux-any] <!nocheck>,
                catch2 (>= 3.0.0) <!nocheck>
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/spdlog
 Vcs-Git: https://salsa.debian.org/med-team/spdlog.git
 Homepage: https://github.com/gabime/spdlog
